#include "os_semaphore.h"
#include <semaphore.h>

#if defined(__unix__) || (defined(__APPLE__) && defined(__MACH__)) // Fuck you, apple

int OSSemaphore_Create(os_semaphore_t* target, unsigned int value)
{
	return sem_init(
			target,
			0, // multi-threaded, not multiprocess
			value
		       );
}

int OSSemaphore_GetValue(os_semaphore_t* semaphore)
{
	int count;
	sem_getvalue(semaphore, &count);
	return count;
}

int OSSemaphore_Wait(os_semaphore_t* semaphore)
{
	return sem_wait(semaphore);
}

int OSSemaphore_Release(os_semaphore_t* semaphore)
{
	return sem_post(semaphore);
}

void OSSemaphore_Destroy(os_semaphore_t* semaphore)
{
	sem_close(semaphore);
	return;
}

#elif defined(_WIN32)

int OSSemaphore_Create(os_semaphore_t* target, unsigned int value)
{
	target->sem_handle = CreateSemaphoreA(
				SEMAPHORE_ALL_ACCESS, // Access attributes
				value,  // InitialCount
				32 767, // POSIX_SEM_VALUE_MAX
				NULL    // Named semaphore
				);
	if (target->sem_handle != NULL) {
		return ENOMEM;
	}


	target->count = value;

	return EXIT_SUCCESS;
}

int OSSemaphore_GetValue(os_semaphore_t* semaphore)
{
	return semaphore->count;
}

int OSSempahore_Wait(os_semaphore_t* semaphore)
{
	DWORD r = WaitForSingleObject(
		semaphore->sem_handle,
		INIFINITE
	);
	semaphore->count -= 1;
	return r != WAIT_FAILED;
}

int OSSempahore_Release(os_semaphore_t* semaphore)
{
	if (ReleaseSemaphore(
		semaphore->sem_handle,
		1,
		NULL
	)) {
		semaphore->count++;
		return EXIT_SUCCESS;
	} else {
		return EXIT_FAILURE;
	}
}

void OSSemaphore_Destroy(os_semaphore_t* semaphore)
{
	CloseHandle(semaphore->sem_handle);
}

#endif
